"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inquirer = require("inquirer");
var questions_1 = require("./questions");
var targets_1 = require("./targets");
var types_1 = require("./types");
var helpers_1 = require("./helpers");
function log() {
    var msgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        msgs[_i] = arguments[_i];
    }
    // tslint:disable-next-line
    console.log.apply(console, msgs);
}
function init() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, possibleTargets, answers, config, relativePath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    log("\n    Welcome to " + helpers_1.bold('GraphQL Code Generator') + "!\n    Answer few questions and we will setup everything for you.\n  ");
                    return [4 /*yield*/, targets_1.guessTargets()];
                case 1:
                    possibleTargets = _b.sent();
                    return [4 /*yield*/, inquirer.prompt(questions_1.getQuestions(possibleTargets))];
                case 2:
                    answers = _b.sent();
                    config = {
                        overwrite: true,
                        schema: answers.schema,
                        documents: answers.targets.includes(types_1.Tags.browser) ? answers.documents : null,
                        generates: (_a = {},
                            _a[answers.output] = {
                                plugins: answers.plugins.map(function (p) { return p.value; })
                            },
                            _a)
                    };
                    // introspection
                    if (answers.introspection) {
                        addIntrospection(config);
                    }
                    relativePath = helpers_1.writeConfig(answers, config).relativePath;
                    // write package.json
                    helpers_1.writePackage(answers, relativePath);
                    // Emit status to the terminal
                    log("\n    Config file generated at " + helpers_1.bold(relativePath) + "\n    \n      " + helpers_1.bold('$ npm install') + "\n\n    To install the plugins.\n\n      " + helpers_1.bold("$ npm run " + answers.script) + "\n\n    To run GraphQL Code Generator.\n  ");
                    return [2 /*return*/];
            }
        });
    });
}
exports.init = init;
// adds an introspection to `generates`
function addIntrospection(config) {
    config.generates['./graphql.schema.json'] = {
        plugins: ['introspection']
    };
}
//# sourceMappingURL=index.js.map